"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.signOutCognito = exports.signOut = exports.getCurrentPoolUserCognito = exports.getCurrentPoolUser = exports.signIn = exports.signInCognito = exports.getAuth = void 0;
var util_1 = require("../util");
var lodash_1 = require("lodash");
var core_1 = require("primeobjects-helper-util/build/cjs/core");
//create aws-amplify/auth object with settings from solution profile
var getAuth = function (solution) { return __awaiter(void 0, void 0, void 0, function () {
    var global, _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                if (!solution.cognito)
                    return [2 /*return*/, undefined];
                global = (0, core_1.getGlobalObject)();
                if (!!global._auth) return [3 /*break*/, 2];
                _a = global;
                return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require("@aws-amplify/auth")); })];
            case 1:
                _a._auth = (_b.sent()).default;
                global._auth.configure(__assign({}, solution.cognito));
                _b.label = 2;
            case 2: return [2 /*return*/, global._auth];
        }
    });
}); };
exports.getAuth = getAuth;
var signInCognito = function (auth, loginId, password) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, new Promise(function (resolve, reject) {
                    auth.signIn(loginId, password)
                        .then(function (data) {
                        resolve(data);
                    })
                        .catch(function (error) {
                        console.error(error);
                        reject(error);
                    });
                })];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.signInCognito = signInCognito;
var signIn = function (solution, data, settings) { return __awaiter(void 0, void 0, void 0, function () {
    var auth, user, password, codes, type_1, userOrgs, users, error_1, organizationId, userId, error_2;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, (0, exports.getAuth)(solution)];
            case 1:
                auth = _a.sent();
                if (!auth)
                    return [2 /*return*/, undefined];
                user = null;
                password = data.password, codes = data.codes;
                if (!(0, core_1.isEmail)(data === null || data === void 0 ? void 0 : data.email) && !(0, core_1.isPhoneNumber)(data === null || data === void 0 ? void 0 : data.mobile)) {
                    return [2 /*return*/, { error: "ERROR_SIGN_IN_NEED_EMAIL" }];
                }
                //console.log({password, rules:solution.auth.passwordRules, result: isPassword(password, solution.auth.passwordRules)});
                if (!(0, core_1.isPassword)(password, __assign(__assign({}, solution === null || solution === void 0 ? void 0 : solution.passwordRules), { allowNilEmpty: true }))) {
                    return [2 /*return*/, { error: "ERROR_SIGN_IN_NEED_PASSWORD" }];
                }
                if ((0, core_1.isNonEmptyString)(codes) && codes.length != 8) {
                    return [2 /*return*/, { error: "ERROR_SIGN_IN_NEED_VERIFY" }];
                }
                _a.label = 2;
            case 2:
                _a.trys.push([2, 4, , 5]);
                if (!(0, core_1.isObject)(settings))
                    settings = {};
                type_1 = settings.type == "mobile" ? settings.type : "email";
                return [4 /*yield*/, (0, util_1.callApiBase)("".concat(solution.apis.organization, "user-orgs"), { type: type_1, value: type_1 == "mobile" ? data === null || data === void 0 ? void 0 : data.mobile : data === null || data === void 0 ? void 0 : data.email }, "GET", {
                        solutionId: solution.id
                    })];
            case 3:
                userOrgs = _a.sent();
                users = (0, lodash_1.without)((0, lodash_1.map)(userOrgs, function (user) {
                    return ((type_1 == "email" && user.emailVerifiedOn) ||
                        (type_1 == "mobile" && user.mobileVerifiedOn)) &&
                        user.stateCode == 0
                        ? user
                        : null;
                }), null);
                switch (users.length) {
                    case 0: {
                        if (userOrgs.length > 0) {
                            if ((0, core_1.libTrackIsOn)())
                                console.log({ userOrgs: userOrgs, users: users });
                            return [2 /*return*/, { error: "ERROR_SIGN_IN_NEED_VERIFY" }];
                        }
                        else {
                            return [2 /*return*/, { error: "ERROR_SIGN_IN_USER_NOT_FOUND" }];
                        }
                    }
                    case 1: {
                        user = userOrgs[0];
                        break;
                    }
                    default: {
                        //If there're more orgs, we will sort by latestSignInOn and modifiedOn field
                        user = userOrgs[0];
                        user.latestSignInOn = user.latestSignInOn
                            ? user.latestSignInOn
                            : user.modifiedOn;
                        (0, lodash_1.each)(userOrgs, function (userOrg) {
                            var dt = userOrg.latestSignInOn
                                ? userOrg.latestSignInOn
                                : userOrg.modifiedOn;
                            user = user.latestSignInOn < dt ? userOrg : user;
                        });
                    }
                }
                return [3 /*break*/, 5];
            case 4:
                error_1 = _a.sent();
                console.error(error_1);
                return [2 /*return*/, { error: "ERROR_SIGN_IN_USER_ORGS", detail: error_1 }];
            case 5:
                _a.trys.push([5, 7, , 8]);
                organizationId = user.organizationId;
                userId = user.id;
                return [4 /*yield*/, (0, exports.signInCognito)(auth, "".concat(organizationId, ".").concat(userId), password)];
            case 6:
                _a.sent();
                return [3 /*break*/, 8];
            case 7:
                error_2 = _a.sent();
                console.error(error_2);
                return [2 /*return*/, { error: "ERROR_SIGN_IN_COGNITO", detail: error_2 }];
            case 8: return [2 /*return*/, { user: user }];
        }
    });
}); };
exports.signIn = signIn;
var getCurrentPoolUser = function (solution) { return __awaiter(void 0, void 0, void 0, function () {
    var auth, win, hasCognito, x;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, (0, exports.getAuth)(solution)];
            case 1:
                auth = _a.sent();
                if (!auth)
                    return [2 /*return*/, undefined];
                win = (0, core_1.getWindow)();
                hasCognito = false;
                for (x in win.localStorage) {
                    if (x.indexOf("CognitoIdentityServiceProvider") >= 0 && !hasCognito) {
                        hasCognito = true;
                    }
                }
                if (!hasCognito)
                    return [2 /*return*/, undefined];
                return [2 /*return*/, (0, exports.getCurrentPoolUserCognito)(auth)];
        }
    });
}); };
exports.getCurrentPoolUser = getCurrentPoolUser;
var getCurrentPoolUserCognito = function (auth) {
    return new Promise(function (resolve) {
        auth.currentUserPoolUser()
            .then(function (user) {
            resolve(user);
        })
            .catch(function (error) {
            console.error(error);
            resolve(undefined);
        })
            .finally(function () { });
    });
};
exports.getCurrentPoolUserCognito = getCurrentPoolUserCognito;
var signOut = function (solution) { return __awaiter(void 0, void 0, void 0, function () {
    var auth;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, (0, exports.getAuth)(solution)];
            case 1:
                auth = _a.sent();
                if (!auth)
                    return [2 /*return*/, false];
                return [4 /*yield*/, (0, exports.signOutCognito)(auth)];
            case 2: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.signOut = signOut;
var signOutCognito = function (auth) {
    return new Promise(function (resolve, reject) {
        auth.currentUserPoolUser()
            .then(function () {
            auth.signOut()
                .then(function () {
                resolve(true);
            })
                .catch(function (error) {
                console.error(error);
                reject(false);
            });
        })
            .catch(function (error) {
            console.error(error);
            reject(false);
        })
            .finally(function () { });
    });
};
exports.signOutCognito = signOutCognito;
//# sourceMappingURL=auth-cognito.js.map