"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListHeaderSection = void 0;
var react_1 = __importStar(require("react"));
var search_1 = __importDefault(require("../search"));
var svg_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/svg"));
var primeobjects_ui_web_store_1 = require("primeobjects-ui-web-store");
var mobx_react_lite_1 = require("mobx-react-lite");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var action_button_1 = __importDefault(require("../../controls/action-button"));
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var dropdown_1 = __importDefault(require("../../controls/antd/dropdown"));
var menu_1 = __importDefault(require("../../controls/antd/menu"));
var popover_1 = __importDefault(require("../../controls/antd/popover"));
var local_storage_1 = require("primeobjects-ui-web-basic/build/cjs/util/local-storage");
exports.ListHeaderSection = (0, mobx_react_lite_1.observer)(function (props) {
    var _a;
    var entity = props.entity, cancelSearch = props.cancelSearch, showTags = props.showTags, query = props.query, hideSearchService = props.hideSearchService;
    var envStore = (0, primeobjects_ui_web_store_1.useEnvStore)();
    var envData = JSON.parse(envStore.data);
    var searching = (_a = envData === null || envData === void 0 ? void 0 : envData.search) === null || _a === void 0 ? void 0 : _a.doing;
    var primaryColor = (0, primeobjects_helper_ui_1.usePrimaryColor)();
    var createButtonText = props.createButtonText
        ? props.createButtonText
        : "New";
    var _b = (0, react_1.useState)(undefined), searchService = _b[0], setSearchService = _b[1];
    var hideCreateButton = entity.disableCreate == true ||
        props.hideCreateButton == true ||
        !props.onClickCreateButton;
    var _c = (0, react_1.useState)(false), openCategories = _c[0], setOpenCategories = _c[1];
    (0, react_1.useEffect)(function () {
        //check whether there is a local saved search service
        var localQueryService = (0, local_storage_1.getLocalStorage)("query-service-".concat(query === null || query === void 0 ? void 0 : query.entityName));
        setSearchService(hideSearchService
            ? "hidden"
            : (query === null || query === void 0 ? void 0 : query.service) != "hidden" && localQueryService
                ? localQueryService
                : (query === null || query === void 0 ? void 0 : query.service)
                    ? query === null || query === void 0 ? void 0 : query.service
                    : "auto");
    }, [query]);
    var onSubmitSearch = function (keywords) {
        props.onSubmitSearch && props.onSubmitSearch(keywords);
    };
    var onRefresh = function () {
        props.onRefresh && props.onRefresh();
    };
    var onClickToggleTagsButton = function () {
        props.onClickToggleTagsButton && props.onClickToggleTagsButton();
    };
    var onClickFilterButton = function () { };
    var onClickCreateButton = function () {
        props.onClickCreateButton &&
            props.onClickCreateButton({
                id: (0, primeobjects_helper_util_1.newGuid)(),
                entityName: entity.entityName,
                entityType: entity.entityType
            });
    };
    var onClickSearchService = function (service) {
        (0, local_storage_1.setLocalStorage)("query-service-".concat(query === null || query === void 0 ? void 0 : query.entityName), service);
        setSearchService(service);
        props.onRefresh && props.onRefresh();
    };
    var renderCurrentSearchServiceName = function () {
        switch (searchService) {
            case "database": {
                return "Simple search engine";
            }
            case "elastic": {
                return "Full-text search engine";
            }
            default: {
                return "Auto search engine";
            }
        }
    };
    return (react_1.default.createElement("div", { className: "w-full flex flex-row py-4 items-center relative bg-white" },
        !props.hideEntityIcon && (react_1.default.createElement("div", { className: "flex ml-4" },
            react_1.default.createElement(svg_1.default, { src: entity.icon, size: 32, color: primeobjects_helper_util_1.COLORS.GRAY["900"] }))),
        props.onSubmitSearch && !props.hideSearch && (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(search_1.default, { searching: searching, onSubmit: onSubmitSearch, placeholder: entity.searchInputPlaceholder
                    ? entity.searchInputPlaceholder
                    : "Search ".concat(entity.uiCollectionName, " ..."), wrapperStyle: searchService == "hidden"
                    ? { height: 32 }
                    : { height: 20 }, wrapperClassName: searchService == "hidden" ? "px-2" : "px-2 pt-2", inputClassName: "max-w-xs", cancelSearch: cancelSearch }),
            searchService != "hidden" && (react_1.default.createElement("div", { className: "absolute cursor-pointer", style: { top: 8, left: 56 } },
                react_1.default.createElement("div", { style: { width: 150 } },
                    react_1.default.createElement(dropdown_1.default, { trigger: ["click"], placement: "top", overlay: react_1.default.createElement(menu_1.default, null,
                            react_1.default.createElement(menu_1.default.Item, { onClick: function () {
                                    return onClickSearchService("auto");
                                } }, "Auto search engine"),
                            react_1.default.createElement(menu_1.default.Item, { onClick: function () {
                                    return onClickSearchService("database");
                                } }, "Simple search engine"),
                            react_1.default.createElement(menu_1.default.Item, { onClick: function () {
                                    return onClickSearchService("elastic");
                                } }, "Full-text search engine")) },
                        react_1.default.createElement("div", { className: "w-full flex" },
                            react_1.default.createElement("div", { className: "text-xs" }, renderCurrentSearchServiceName()),
                            react_1.default.createElement(svg_1.default, { style: { margin: 4 }, src: "/icons/platform/down.svg", size: 10, color: primeobjects_helper_util_1.COLORS.GRAY["900"] })))))))),
        react_1.default.createElement("div", { className: "flex mr-4" },
            props.hideCategoriesButton != true &&
                props.renderCategories && (react_1.default.createElement(popover_1.default, { placement: "bottomRight", open: openCategories, onOpenChange: function (newOpen) {
                    setOpenCategories(newOpen);
                }, trigger: "click", content: react_1.default.createElement("div", { style: { width: 350 } }, props.renderCategories(function () {
                    setOpenCategories(false);
                })) },
                react_1.default.createElement(action_button_1.default, { id: "list-header-categories", iconSrc: "/icons/platform/categories.svg" }))),
            props.onRefresh && (react_1.default.createElement(action_button_1.default, { id: "list-header-refresh", onClick: onRefresh, iconSrc: "/icons/platform/refresh.svg" })),
            props.onClickToggleTagsButton && (react_1.default.createElement(action_button_1.default, { id: "list-header-filter", onClick: onClickToggleTagsButton, iconSrc: "/icons/platform/tags.svg", tooltipText: "Toggle tags", iconColor: showTags ? primaryColor["600"] : undefined })),
            props.onClickFilterButton && (react_1.default.createElement(action_button_1.default, { id: "list-header-filter", onClick: onClickFilterButton, iconSrc: "/icons/platform/filter.svg" })),
            !hideCreateButton && (react_1.default.createElement(action_button_1.default, { id: "list-header-new", onClick: onClickCreateButton, wrapperClassName: "bg-green-500 hover:bg-green-600", text: createButtonText, textColor: primeobjects_helper_util_1.COLORS.WHITE })))));
});
exports.default = exports.ListHeaderSection;
//# sourceMappingURL=header.js.map