"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListSection = void 0;
var react_1 = __importStar(require("react"));
var lodash_1 = require("lodash");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var header_1 = __importDefault(require("./header"));
var filters_1 = __importDefault(require("./filters"));
var table_1 = __importDefault(require("./table"));
var empty_1 = __importDefault(require("./empty"));
var util_1 = require("./util");
var local_storage_1 = require("primeobjects-ui-web-basic/build/cjs/util/local-storage");
var util_2 = require("../../util");
var auth_call_api_1 = require("../../context/auth-call-api");
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var notification_1 = __importDefault(require("../../controls/antd/notification"));
var ListFiltersSection = undefined;
var ListTableSection = undefined;
var ListHeaderSection = undefined;
var ListEmptySection = undefined;
var generateQuery = function (listQuery) {
    var name = listQuery.name, pageNumber = listQuery.pageNumber, keywords = listQuery.keywords, tags = listQuery.tags, nodes = listQuery.nodes, conditions = listQuery.conditions, scope = listQuery.scope, recordForMembership = listQuery.recordForMembership;
    var query = __assign(__assign({ name: name, orderBy: [{ type: "desc", attribute: "_ts" }], scope: scope ? scope : "organization", conditions: [{ attribute: "stateCode", op: ">=", value: 0 }], pageSize: 25, pageNumber: pageNumber ? pageNumber : 1 }, (listQuery.query ? listQuery.query : {})), { prevListQuery: JSON.stringify(listQuery) });
    // if (_track) console.log({ recordForMembership, scope });
    if (conditions) {
        query.conditions = (0, lodash_1.filter)((0, lodash_1.unionBy)(query.conditions, conditions, function (v) {
            return JSON.stringify(v);
        }), function (f) {
            return f.remove != true;
        });
    }
    if (recordForMembership &&
        recordForMembership.id &&
        query.scope == "membership") {
        query.scope = "membership";
        query.recordIdForMembership = recordForMembership.id;
    }
    if ((0, primeobjects_helper_util_1.isNonEmptyString)(keywords)) {
        query.keywords = keywords;
    }
    if ((0, lodash_1.isArray)(tags) && tags.length > 0) {
        query.tags = tags;
    }
    if (nodes && nodes.length > 0) {
        var treeFilters = {};
        for (var i = 0; i < nodes.length; i++) {
            var node = nodes[i];
            if (!treeFilters[node.attributeName])
                treeFilters[node.attributeName] = [];
            treeFilters[node.attributeName].push(node.id);
        }
        query.treeFilters = treeFilters;
    }
    return query;
};
var ListSection = function (props) {
    var _a, _b;
    if (!ListFiltersSection) {
        console.log("Get global components in /sections/list/index.tsx");
        ListFiltersSection = (0, util_2.getGlobalComponent)("ListFiltersSection", filters_1.default);
        ListTableSection = (0, util_2.getGlobalComponent)("ListTableSection", table_1.default);
        ListHeaderSection = (0, util_2.getGlobalComponent)("ListHeaderSection", header_1.default);
        ListEmptySection = (0, util_2.getGlobalComponent)("ListEmptySection", empty_1.default);
    }
    var currentRecord = props.currentRecord, recordToUpdate = props.recordToUpdate, hideHeader = props.hideHeader, createButtonText = props.createButtonText, hideSearch = props.hideSearch, hideSearchService = props.hideSearchService, showFilterButton = props.showFilterButton, showToggleTagsButton = props.showToggleTagsButton, hideRefreshButton = props.hideRefreshButton, hideCreateButton = props.hideCreateButton, hideCategoriesButton = props.hideCategoriesButton, hideEntityIcon = props.hideEntityIcon, minWidth = props.minWidth, showScrollbarX = props.showScrollbarX, apis = props.apis, recordForMembership = props.recordForMembership, defaultRecordId = props.defaultRecordId;
    var wrapperClassName = (0, primeobjects_helper_util_1.isNonEmptyString)(props.wrapperClassName)
        ? props.wrapperClassName
        : "";
    var wrapperStyle = (0, primeobjects_helper_util_1.isObject)(props.wrapperStyle) ? props.wrapperStyle : {};
    var _c = (0, react_1.useState)({}), ui = _c[0], setUI = _c[1];
    var _d = (0, react_1.useState)(undefined), query = _d[0], setQuery = _d[1];
    var _e = (0, react_1.useState)(0), filterSectionHeight = _e[0], setFilterSectionHeight = _e[1];
    var keywords = ui.keywords;
    var tags = ui.tags;
    var nodes = ui.nodes;
    var conditions = ui.conditions;
    var solution = (0, primeobjects_helper_ui_1.useSolution)();
    var primaryColorName = (0, primeobjects_helper_ui_1.usePrimaryColorName)();
    var showTags = ui.showTags;
    var entity = query && (0, primeobjects_helper_util_1.getEntity)(solution, query.entityName, query.entityType);
    var _f = (0, react_1.useState)(""), refresh = _f[0], setRefresh = _f[1];
    var _g = (0, react_1.useState)(undefined), notification = _g[0], setNotification = _g[1];
    var _h = (0, react_1.useState)(undefined), cancelSearch = _h[0], setCancelSearch = _h[1];
    var _j = (0, react_1.useState)(undefined), recordInAction = _j[0], setRecordInAction = _j[1];
    var _k = (0, react_1.useState)(undefined), recordDeleted = _k[0], setRecordDeleted = _k[1];
    var localStorageKey = "list-ui-".concat(entity === null || entity === void 0 ? void 0 : entity.entityName, "-").concat(entity === null || entity === void 0 ? void 0 : entity.entityType);
    var filters = __spreadArray(__spreadArray(__spreadArray(__spreadArray([], (keywords ? [{ type: "search", text: keywords }] : []), true), (0, lodash_1.map)(tags, function (tag) {
        return { type: "tag", text: tag };
    }), true), (0, lodash_1.map)(nodes, function (node) {
        return __assign(__assign({}, node), { type: "node" });
    }), true), (0, lodash_1.map)(conditions, function (condition) {
        return __assign(__assign({}, condition), { type: "condition" });
    }), true);
    var hideFilterSection = props.hideFilterSection == true || filters.length == 0;
    (0, react_1.useEffect)(function () { }, [entity === null || entity === void 0 ? void 0 : entity.entityName, entity === null || entity === void 0 ? void 0 : entity.entityType]);
    (0, react_1.useEffect)(function () {
        updateUI(__assign(__assign({}, ui), { nodes: (0, lodash_1.cloneDeep)(props.nodes) }));
    }, [props.nodes]);
    (0, react_1.useEffect)(function () {
        updateUI(__assign(__assign({}, ui), { tags: (0, lodash_1.cloneDeep)(props.tags) }));
    }, [props.tags]);
    (0, react_1.useEffect)(function () {
        if (!(0, lodash_1.isNil)(props.resetUI)) {
            setCancelSearch(Date.now());
            updateUI({});
        }
    }, [props.resetUI]);
    (0, react_1.useEffect)(function () {
        var newLisyQuery = {
            name: "first",
            keywords: keywords,
            tags: tags,
            nodes: nodes,
            conditions: conditions,
            recordForMembership: recordForMembership,
            query: props.query
        };
        if ((query === null || query === void 0 ? void 0 : query.prevListQuery) != JSON.stringify(newLisyQuery)) {
            setQuery(generateQuery(newLisyQuery));
        }
    }, [recordForMembership, tags, nodes, conditions, keywords, props.query]);
    // const onCreateRecord = (record: Record<string, any>) => {
    //     props.onCreateRecord && props.onCreateRecord(record);
    // };
    (0, react_1.useEffect)(function () {
        var _a;
        if ((_a = props.recordToDelete) === null || _a === void 0 ? void 0 : _a.id)
            onDeleteRecord(props.recordToDelete);
    }, [props.recordToDelete]);
    (0, react_1.useEffect)(function () {
        var _a;
        if ((_a = props.recordDeleted) === null || _a === void 0 ? void 0 : _a.id)
            setRecordDeleted(props.recordDeleted);
    }, [props.recordDeleted]);
    (0, react_1.useEffect)(function () {
        if (!(0, lodash_1.isNil)(props.refresh))
            onRefresh();
    }, [props.refresh]);
    var updateUI = function (newFilters) {
        (0, local_storage_1.setLocalStorage)(localStorageKey, newFilters);
        setUI(newFilters);
    };
    var onApplyConditions = function (conditions) {
        console.log({ conditions: conditions });
        updateUI(__assign(__assign({}, ui), { conditions: conditions }));
    };
    var onSubmitSearch = function (keywords) {
        updateUI(__assign(__assign({}, ui), { keywords: keywords ? keywords : "" }));
    };
    var onClickTag = function (tag) {
        updateUI(__assign(__assign({}, ui), { tags: [tag] }));
    };
    var onRefresh = function () {
        setRecordInAction({ doing: false, record: {}, actionName: "refresh" });
        setRefresh((0, primeobjects_helper_util_1.newGuid)());
    };
    var onClickToggleTagsButton = function () {
        var showTags = !(ui.showTags == true);
        updateUI(__assign(__assign({}, ui), { showTags: showTags }));
    };
    var getCurrentRecord = function () {
        return currentRecord;
    };
    var getColumns = function (onClick, entity, settings) {
        var _a;
        var func = (_a = props.getColumns) !== null && _a !== void 0 ? _a : util_1.DEFAULT_LIST_COLUMNS;
        return func(onClick, entity, settings
            ? __assign(__assign({}, settings), { ui: ui, onApplyConditions: onApplyConditions, getCurrentRecord: getCurrentRecord }) : { onApplyConditions: onApplyConditions, getCurrentRecord: getCurrentRecord });
    };
    var onClickFilterButton = function () { };
    var onEditRecord = function (record, action, entity, rowIndex) {
        props.onEditRecord &&
            props.onEditRecord((0, lodash_1.cloneDeep)(record), action, entity, rowIndex);
    };
    var onDeleteRecord = function (record) {
        setRecordInAction({
            doing: true,
            record: record,
            actionName: "deleting",
            actionMessage: "Deleting ...",
            color: (0, primeobjects_helper_util_1.getColor)(primaryColorName, 600)
        });
        var apiEndpoint = apis
            ? (0, util_2.getApiEndpointBase)(apis, "data", "delete")
            : (0, util_2.getApiEndpoint)(solution, "data", "delete", entity === null || entity === void 0 ? void 0 : entity.entityName);
        apiEndpoint &&
            (0, auth_call_api_1.callApi)(solution, apiEndpoint, 
            //"http://localhost:3000/prod/delete",
            { id: record.id }, "DELETE")
                .then(function (result) {
                (0, primeobjects_helper_util_1.doNothing)(result);
                setRecordInAction({
                    doing: false,
                    record: {},
                    actionName: "deleted-done",
                    color: (0, primeobjects_helper_util_1.getColor)(primaryColorName, 600)
                });
                setNotification({
                    type: "success",
                    refresh: (0, primeobjects_helper_util_1.getTimestamp)(),
                    message: "Record has been deleted successfully."
                });
                setRecordDeleted(record);
                props.onDeleteRecord && props.onDeleteRecord(record);
            })
                .catch(function (error) {
                console.error(error);
                setRecordInAction({
                    doing: false,
                    record: {},
                    actionName: "delete-failed"
                });
                setNotification({
                    type: "error",
                    refresh: (0, primeobjects_helper_util_1.getTimestamp)(),
                    message: "Failed to delete the record! Please try again later."
                });
            });
    };
    var onLoadSuccess = function (query, result) {
        props.onLoadSuccess && props.onLoadSuccess(query, result);
    };
    var onCloneRecord = function (record, action, entity, rowIndex) {
        (0, primeobjects_helper_util_1.doNothing)({ action: action, rowIndex: rowIndex });
        setRecordInAction({
            doing: true,
            record: record,
            actionName: "cloning",
            actionMessage: "Cloning ...",
            color: primaryColorName
        });
        var apiEndpoint = apis
            ? (0, util_2.getApiEndpointBase)(apis, "data", "clone")
            : (0, util_2.getApiEndpoint)(solution, "data", "clone", entity === null || entity === void 0 ? void 0 : entity.entityName);
        apiEndpoint &&
            (0, auth_call_api_1.callApi)(solution, apiEndpoint, 
            //"http://localhost:3000/prod/clone",
            {
                entity: entity,
                data: record,
                displayFieldName: entity &&
                    (0, lodash_1.isArray)(entity.displayFields) &&
                    entity.displayFields.length > 0
                    ? entity.displayFields[0]
                    : ""
            }, "POST")
                .then(function (result) {
                setRecordInAction({
                    doing: false,
                    record: {},
                    actionName: "clone-done"
                });
                setNotification({
                    type: "success",
                    refresh: (0, primeobjects_helper_util_1.getTimestamp)(),
                    message: "Record has been cloned successfully."
                });
                props.onCloneRecord && props.onCloneRecord(result);
            })
                .catch(function (error) {
                console.error(error);
                setRecordInAction({
                    doing: false,
                    record: {},
                    actionName: "clone-failed"
                });
                setNotification({
                    type: "error",
                    refresh: (0, primeobjects_helper_util_1.getTimestamp)(),
                    message: "Failed to clone the record! Please try again later."
                });
            });
    };
    var onRemoveFilter = function (f) {
        var newData = [];
        switch (f.type) {
            case "search": {
                setCancelSearch(Date.now());
                break;
            }
            case "node": {
                var newNodes = (0, lodash_1.filter)(nodes, function (node) {
                    return node.id != f.id;
                });
                newData = newNodes;
                updateUI(__assign(__assign({}, ui), { nodes: newNodes }));
                break;
            }
            case "condition": {
                var newConditions = (0, lodash_1.filter)(conditions, function (c) {
                    return ("".concat(f.attribute, "-").concat(f.value, "-").concat(f.op) !=
                        "".concat(c.attribute, "-").concat(c.value, "-").concat(c.op));
                });
                newData = newConditions;
                updateUI(__assign(__assign({}, ui), { conditions: newConditions }));
                break;
            }
            case "tag": {
                newData = []; //TODO: allow remove a single tag
                updateUI(__assign(__assign({}, ui), { tags: [] }));
                break;
            }
        }
        props.onRemoveFilter && props.onRemoveFilter(f, newData);
    };
    var onClickRecord = function (record, action, entity, rowIndex) {
        props.onClickRecord &&
            props.onClickRecord(record, action, entity, rowIndex);
    };
    var renderEmptyTable = function () {
        return (react_1.default.createElement(ListEmptySection, { entity: entity, search: keywords, tags: tags, nodes: nodes, conditions: conditions }));
    };
    var onResizeFilter = function (width, height) {
        (0, primeobjects_helper_util_1.doNothing)(width);
        setFilterSectionHeight((height !== null && height !== void 0 ? height : 0) + 24); //NOTE: 24 is padding, if we change the padding of filter section, we should also change 24
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: "list w-full h-full flex flex-col overflow-x-hidden ".concat(wrapperClassName), style: wrapperStyle },
            !hideHeader && entity && (react_1.default.createElement(ListHeaderSection, { hide: true, currentRecord: currentRecord, entity: entity, showTags: showTags, onClickFilterButton: showFilterButton ? onClickFilterButton : undefined, onClickToggleTagsButton: showToggleTagsButton
                    ? onClickToggleTagsButton
                    : undefined, renderCategories: props.renderCategories, onClickCreateButton: props.onCreateRecord, hideCategoriesButton: hideCategoriesButton, hideCreateButton: hideCreateButton, hideEntityIcon: hideEntityIcon, hideSearchService: hideSearchService, hideSearch: hideSearch, onSubmitSearch: onSubmitSearch, onRefresh: hideRefreshButton ? undefined : onRefresh, cancelSearch: cancelSearch, createButtonText: createButtonText, query: query })),
            !hideFilterSection && entity && (react_1.default.createElement(ListFiltersSection, { wrapperStyle: {
                    borderTop: "1px solid #f0f0f0"
                }, filters: filters, onRemove: onRemoveFilter, onResize: onResizeFilter })),
            entity && (react_1.default.createElement(ListTableSection, { wrapperStyle: __assign({ height: "calc(100% - (".concat(65 +
                        (hideFilterSection ? 0 : filterSectionHeight), "px)"), borderTop: "1px solid #f0f0f0" }, ((_a = props.tableWrapperStyle) !== null && _a !== void 0 ? _a : {})), wrapperClassName: (_b = props.tableWrapperClassName) !== null && _b !== void 0 ? _b : "", showInfoHeader: props.hideInfoHeader != true, infoHeaderContent: props.infoHeaderContent, showInfoFooter: props.hideInfoFooter != true, infoFooterContent: props.infoFooterContent, show: true, apis: apis, recordInAction: recordInAction, recordToUpdate: recordToUpdate, recordDeleted: recordDeleted, onClickTag: onClickTag, showTags: showTags, refresh: refresh, onEditRecord: onEditRecord, onDeleteRecord: onDeleteRecord, onCloneRecord: onCloneRecord, onApplyConditions: onApplyConditions, onLoadPostProcess: props.onLoadPostProcess, onLoadSuccess: onLoadSuccess, onLoadFailed: props.onLoadFailed, manualLoadMore: props.manualLoadMore, defaultRecordId: defaultRecordId, query: query, getColumns: getColumns, minWidth: minWidth, showScrollbarX: showScrollbarX, onClickRecord: onClickRecord, renderEmptyTable: renderEmptyTable })),
            (0, lodash_1.isNil)(query) && (react_1.default.createElement("div", { className: "w-full p-4 flex flex-col text-red-600" }, "The query is not defined.")),
            !(0, lodash_1.isNil)(query) && !entity && (react_1.default.createElement("div", { className: "w-full p-4 flex flex-col text-red-600" }, "The entity does not exist."))),
        react_1.default.createElement(notification_1.default, __assign({ id: "list-notification", placement: "bottom" }, notification))));
};
exports.ListSection = ListSection;
exports.default = exports.ListSection;
//# sourceMappingURL=index.js.map