"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteTagsSection = void 0;
var react_1 = __importDefault(require("react"));
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var site_title_1 = __importDefault(require("./site-title"));
var tags_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/tags"));
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var SiteTagsSection = function (props) {
    var colorName = props.colorName, title = props.title, subTitle = props.subTitle, titleSize = props.titleSize, subTitleSize = props.subTitleSize, data = props.data, tagClassName = props.tagClassName, textClassName = props.textClassName, textStyle = props.textStyle, tagBorderClassName = props.tagBorderClassName, disableShorten = props.disableShorten;
    var wrapperClassName = (0, core_1.isNonEmptyString)(props.wrapperClassName)
        ? props.wrapperClassName
        : "";
    var tagsClassName = (0, core_1.isNonEmptyString)(props.tagsClassName)
        ? props.tagsClassName
        : "";
    var titleClassName = (0, core_1.isNonEmptyString)(props.titleClassName)
        ? props.titleClassName
        : "";
    var subTitleClassName = (0, core_1.isNonEmptyString)(props.subTitleClassName)
        ? props.subTitleClassName
        : "";
    var primaryColor = (0, primeobjects_helper_ui_1.usePrimaryColor)();
    return data.length > 0 ? (react_1.default.createElement("div", { className: "w-full ".concat(wrapperClassName) },
        react_1.default.createElement(site_title_1.default, { title: title, subTitle: subTitle, titleSize: titleSize, subTitleSize: subTitleSize, titleClassName: "text-left text-".concat(primaryColor.name, "-600 ").concat(titleClassName), subTitleClassName: "text-left ".concat(subTitleClassName) }),
        react_1.default.createElement("div", { className: "flex flex-col pt-2 ".concat(tagsClassName) },
            react_1.default.createElement(tags_1.default, { data: data, tooltipColorName: colorName, onClick: props.onClick, textStyle: textStyle, textClassName: textClassName, tagClassName: tagClassName, borderClassName: tagBorderClassName, disableShorten: disableShorten })))) : (react_1.default.createElement(react_1.default.Fragment, null));
};
exports.SiteTagsSection = SiteTagsSection;
exports.default = exports.SiteTagsSection;
//# sourceMappingURL=site-tags.js.map