//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from "react";
import { SiteSubmitEmailSection } from "./site-submit-email";
import { isNil } from "lodash";
import { isNonEmptyString } from "primeobjects-helper-util";
import { getSolution, usePrimaryColorName } from "primeobjects-helper-ui";
export var SiteIntroSection = function (props) {
    var submitEmailSettings = props.submitEmailSettings, title = props.title, subTitle = props.subTitle, titleTag = props.titleTag, bookMeetingSettings = props.bookMeetingSettings;
    var solution = props.solution ? props.solution : getSolution();
    var primaryColorName = usePrimaryColorName(solution);
    var colorName = props.colorName ? props.colorName : primaryColorName;
    return (React.createElement("div", { className: "text-left" },
        titleTag == "h2" ? (React.createElement("h2", { className: "text-4xl font-extrabold text-gray-900 md:text-5xl sm:max-w-xl sm:mx-auto text-left lg:mx-0 mb-8 leading-tight", dangerouslySetInnerHTML: { __html: title } })) : (React.createElement("h1", { className: "text-4xl font-extrabold text-gray-900 md:text-5xl sm:max-w-xl sm:mx-auto text-left lg:mx-0 mb-8 leading-tight", dangerouslySetInnerHTML: { __html: title } })),
        !isNil(subTitle) && isNonEmptyString(subTitle) && (React.createElement("p", { className: "mt-3 text-lg text-gray-500 sm:mt-5 sm:max-w-xl sm:mx-auto md:mt-5 md:text-xl lg:mx-0", dangerouslySetInnerHTML: { __html: subTitle } })),
        !isNil(submitEmailSettings) && (React.createElement("div", { className: "text-left mt-8 sm:max-w-xl sm:mx-auto md:mt-12 lg:mx-0" },
            isNonEmptyString(submitEmailSettings === null || submitEmailSettings === void 0 ? void 0 : submitEmailSettings.title) && (React.createElement("div", { className: "w-full" },
                React.createElement("p", { className: "inline text-lg font-semibold text-".concat(colorName, "-600") }, submitEmailSettings === null || submitEmailSettings === void 0 ? void 0 : submitEmailSettings.title))),
            React.createElement("div", { className: "w-full" },
                React.createElement(SiteSubmitEmailSection, __assign({}, submitEmailSettings, { colorName: colorName, solution: solution }))))),
        !isNil(bookMeetingSettings) && (React.createElement("div", { className: "text-left mt-8 sm:max-w-xl sm:mx-auto md:mt-12 lg:mx-0" },
            isNonEmptyString(submitEmailSettings === null || submitEmailSettings === void 0 ? void 0 : submitEmailSettings.title) && (React.createElement("div", { className: "w-full" },
                React.createElement("p", { className: "inline text-lg font-semibold text-".concat(colorName, "-600") }, bookMeetingSettings === null || bookMeetingSettings === void 0 ? void 0 : bookMeetingSettings.title))),
            React.createElement("div", { className: "w-full" },
                React.createElement(SiteSubmitEmailSection, __assign({}, bookMeetingSettings, { colorName: colorName, solution: solution })))))));
};
export default SiteIntroSection;
//# sourceMappingURL=site-intro.js.map